SETPGID(2)

NAME
setpgid, getpgrp, setpgrp - set/get process group

SYNOPSIS
#include <unistd.h>

int setpgid(pid_t pid, pid_t pgid);
pid_t getpgrp(void);
int setpgrp(void);

DESCRIPTION
setpgid sets the process group ID of the process specified by pid to pgid. If pid is zero, the process ID of the current process is used. If pgid is zero, the process ID of the process specified by pid is used. The process group of the current process is returned by getpgrp. In the Linux DLL 4.4.1 library, setpgrp simply calls setpgid(0,0). Process groups are used for distribution of signals, and by terminals to arbitrate requests for their input: processes that have the same process group as the terminal are foreground and may read, while others will block with a signal if they attempt to read. This call is thus used by programs such as csh(1) to create process groups in implementing job control. The TIOCGPGRP and TIOCSPGRP calls described in termios(4) are used to get/set the process group of the control terminal.

RETURN VALUE
On success, setpgid and setpgrp return zero. On error, -1 is returned, and errno is set appropriately. getpgrp always returns the current process group.

ERRORS

EINVAL
    pgid is less than 0.

EPERM
    Various permission violations.

ESRCH
    pid does not match any process.

SEE ALSO
getuid(2), setsid(2), tcsetpgrp(3), termios(4)